/*
 *  This sketch sends data via HTTP GET requests to data.sparkfun.com service.
 *
 *  You need to get streamId and privateKey at data.sparkfun.com and paste them
 *  below. Or just customize this script to talk to other HTTP servers.
 *  Descrizione su http://www.piersoft.it/?p=485 
 */

#include <ESP8266WiFi.h>
#include <OneWire.h>
#include <DallasTemperature.h>
int DS18B20_Pin = 0;
#define ESP8266_LED 2
OneWire ds(DS18B20_Pin);
DallasTemperature sensors(&ds);
const char* ssid     = "Piersoft"; 
const char* password = "12345678";

const char* host = "54.86.132.254";
const char* publicKey = "inserire chiave pubblica sparkfun";
const char* privateKey = "inserire chiave privata sparkfun";
const char* host1 = "184.106.153.149";
const char* privateKey1="inserire chiave privata di ThingSpeak Twitter App";

void setup() {
  
  Serial.begin(9600);
  sensors.begin();
  delay(100);
  pinMode(ESP8266_LED, OUTPUT);

  // We start by connecting to a WiFi network

  Serial.println();
  Serial.println();
  Serial.print("ESP8266 Connecting to ");
  Serial.println(ssid);
  
  WiFi.begin(ssid, password);
  
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  Serial.println("");
  Serial.println("WiFi connected");  
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
}
void(* resetFunc) (void) = 0;
void loop() {
  pinMode(ESP8266_LED, LOW);
  delay(1000);
  
  // Use WiFiClient class to create TCP connections
  WiFiClient client;
  const int httpPort = 80;
  Serial.print("connecting to ");
  Serial.println(host1);
  if (!client.connect(host1, httpPort)) {
    Serial.println("connection Twitter failed");
   setup();
   // return;
  }

 sensors.requestTemperatures(); // Invia il comando di lettura delle temperatura
 float f =sensors.getTempCByIndex(0);

 
String url1 = "/apps/thingtweet/1/statuses/update?"; 
  url1 += "api_key=";
  url1 += privateKey1;
  url1 += "&status=@vostroaccounttwitter temperatura esterna: "; //inserire il proprio account twitterT
  url1 += f;
  
  delay(10);
  Serial.print("Requesting URL Twitter: ");
    Serial.println(url1);
  // This will send the request to the server
  
   client.print(String("GET ") + url1 + " HTTP/1.1\r\n" +
               "Host: " + host1 + "\r\n" + 
               "Connection: close\r\n\r\n");
  

// Read all the lines of the reply from server and print them to Serial
  while(client.available()){
    String line = client.readStringUntil('\r');
    Serial.print(line);
  }
  
  Serial.println();
  Serial.println("closing connection Twitter");

  
delay(2000); 
Serial.print("connecting to ");
  Serial.println(host);
if (!client.connect(host, httpPort)) {
    Serial.println("connection failed");
   setup();
   // return;
  }
  
  // We now create a URI for the request
  String url = "/input/"; 
  url += publicKey;
  url += "?private_key=";
  url += privateKey;
  url += "&temp=";
  url += f;
  
  Serial.print("Requesting URL: ");
  Serial.println(url);
  
  // This will send the request to the server
  client.print(String("GET ") + url + " HTTP/1.1\r\n" +
               "Host: " + host + "\r\n" + 
               "Connection: close\r\n\r\n");
  pinMode(ESP8266_LED, HIGH);
  delay(200);
  pinMode(ESP8266_LED, LOW);
  delay(200);
  pinMode(ESP8266_LED, HIGH);
  delay(200);
  pinMode(ESP8266_LED, LOW);
  delay(200);
  pinMode(ESP8266_LED, HIGH);
  delay(200);
  pinMode(ESP8266_LED, LOW);
  delay(200);
  pinMode(ESP8266_LED, HIGH);
  delay(200);
  pinMode(ESP8266_LED, LOW);
  delay(200);
// Read all the lines of the reply from server and print them to Serial
  while(client.available()){
    String line = client.readStringUntil('\r');
    Serial.print(line);
  }
  
  Serial.println();
  Serial.println("closing connection Data");
  


   //delay(60000); // Send data every 1 minutes
  delay(600000); // Send data every 10 minutes
  resetFunc();
}

